// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "prefabs/ui/UIBorderPrefab.hpp"
#include "visualnovel/ui/VisualNovelTextbox.hpp"

namespace Dawn {
  class VisualNovelTextboxPrefab :
    public UIPrefab<VisualNovelTextbox, VisualNovelTextboxPrefab>
  {
    public:
      static std::vector<Asset*> prefabAssets(AssetManager *man) {
        std::vector<Asset*> assets;
        assets.push_back(man->get<TrueTypeAsset>("truetype_ark"));
        return assets;
      }
  
      static void prefabApply(AssetManager *man, VisualNovelTextbox *textbox) {
        auto assetFont = man->get<TrueTypeAsset>("truetype_ark");
        UIBorderPrefab::apply(&textbox->border);
        textbox->setFont(&assetFont->font);
        textbox->setFontSize(40);
        textbox->setLabelPadding(glm::vec2(10, 8));
        textbox->setTransform(
          UI_COMPONENT_ALIGN_STRETCH, UI_COMPONENT_ALIGN_END,
          glm::vec4(0, 238, 0, 0),
          0.0f
        );
      }
  };
}